---
jupyter:
  jupytext:
    notebook_metadata_filter: all
    text_representation:
      extension: .md
      format_name: markdown
      format_version: '1.1'
      jupytext_version: 1.1.7
  kernelspec:
    display_name: Python 3
    language: python
    name: python3
  language_info:
    codemirror_mode:
      name: ipython
      version: 3
    file_extension: .py
    mimetype: text/x-python
    name: python
    nbconvert_exporter: python
    pygments_lexer: ipython3
    version: 3.6.5
  plotly:
    description: Using Plotly FigureWidgets with Jupyter Lab
    display_as: chart_events
    language: python
    layout: base
    name: Jupyter Lab with FigureWidget
    order: 2
    permalink: python/jupyter-lab-tools/
    thumbnail: thumbnail/figurewidget-jupyterlab.png
---

#### Create a New View for Output


Display a FigureWidget and then create a new window to display it in so that you can scroll through your code but still keep an eye on what you're doing.


<img src='https://raw.githubusercontent.com/michaelbabyn/plot_data/master/create_view_for_output_jupyter_lab.gif'>

#### View Live Updates

With the output view it is easy to take full advantage of FigureWidgets new imperative-style graph updates since you can see your code and your graph at the same time.

<img src='https://raw.githubusercontent.com/michaelbabyn/plot_data/master/demonstrate_view_jupyter_lab.gif'>



#### Reference


See [these Jupyter notebooks](https://github.com/jonmmease/plotly_ipywidget_notebooks) for even more FigureWidget examples.
